<template>
    <div class="dialog-table-container">
        <el-table
            height="500"
            border
            :span-method="objectSpanMethod"
            align="center"
            :data="tableData"
            id="mix-table-bigger"
            class="dialog_table"
            :cell-style="{'text-align': 'center'}"
            :header-cell-style="{'text-align': 'center'}"
        >
            <el-table-column type="index" label="序号" width="60">
            </el-table-column>
            <el-table-column prop="name" label="项目名称" width="260">
            </el-table-column>
            <el-table-column prop="a" label="月度计划"></el-table-column>
            <el-table-column prop="c" label="计划类型" width="140">
            </el-table-column>

            <el-table-column prop="isOver" label="完成状态" width="120">
                <template v-slot="{row}">
                    <el-tag type="success" effect="dark" v-if="row.isOver === 1"
                        >已完成</el-tag
                    >
                    <el-tag
                        type="danger"
                        effect="dark"
                        v-else-if="row.isOver === 0"
                        >未完成</el-tag
                    >
                    <span v-else>-</span>
                </template>
            </el-table-column>
        </el-table>
        <!--    <pagenation @currentChange="pageChange" class="pagenation"></pagenation>-->
    </div>
</template>
<script>
import pagenation from './pagenation.vue'
import apiList from '@/api/bigScreen/majorView.js'
import utils from '@/utils.js'
export default {
    name: 'quantitativeObjectives',
    components: {pagenation},
    props: {
        tableOptions: {
            type: Object,
            default: () => {
                return {}
            },
        },
    },
    data() {
        return {
            loading: false,
            loadingColor: 'rgba(6, 46, 106, 0.4)',
            dataReady: false,
            tableData: [
                {
                    id: 1,
                    name: '推动数字重庆建设',
                    a: '计划内容',
                    c: '形成制度成果',
                    isOver: 1,
                },
                {
                    id: 2,
                    name: '推动数字重庆建设',
                    a: '计划内容',
                    c: '形成制度成果',
                    isOver: 1,
                },
                {
                    id: 3,
                    name: '推动数字重庆建设',
                    a: '计划内容',
                    c: '形成制度成果',
                    isOver: 1,
                },
                {
                    id: 4,
                    name: '推动数字重庆建设',
                    a: '计划内容',
                    c: '形成制度成果',
                    isOver: 1,
                },
                {
                    id: 5,
                    name: '推动数字重庆建设',
                    a: '计划内容',
                    c: '形成制度成果',
                    isOver: 1,
                },
                {
                    id: 6,
                    name: '全市开发区（园区）数',
                    a: '计划内容',
                    c: '搭建重要平台',
                    isOver: 1,
                },
                {
                    id: 7,
                    name: '全市开发区（园区）数',
                    a: '计划内容',
                    c: '搭建重要平台',
                },
                {
                    id: 8,
                    name: '探索制造业“亩均论英雄”改革',
                    a: '计划内容',
                    c: '上线应用平台',
                    isOver: 1,
                },
                {
                    id: 9,
                    name: '探索制造业“亩均论英雄”改革',
                    a: '计划内容',
                    c: '上线应用平台',
                    isOver: 0,
                },
                {
                    id: 10,
                    name: '实施国企战略性重组和专业化整合',
                    a: '计划内容',
                    c: '其他',
                    isOver: 1,
                },
                {
                    id: 11,
                    name: '建立企业上市助推机制',
                    a: '计划内容',
                    c: '其他',
                    isOver: 1,
                },
                {
                    id: 12,
                    name: '探索强村富民综合改革',
                    a: '计划内容',
                    c: '其他',
                },
                {
                    id: 13,
                    name: '探索经济区与行政区适度分离改革',
                    a: '计划内容',
                    c: '其他',
                    isOver: 1,
                },
                {
                    id: 14,
                    name: '推进涉企涉民服务全生命周期“一件事一次办”',
                    a: '计划内容',
                    c: '其他',
                    isOver: 0,
                },
                {
                    id: 15,
                    name: '打造“信用重庆”升级版',
                    a: '计划内容',
                    c: '其他',
                    isOver: 1,
                },
                {
                    id: 16,
                    name: '建设政企学研深度融合的现代职教体系',
                    a: '计划内容',
                    c: '其他',
                    isOver: 0,
                },
                {
                    id: 17,
                    name: '健全平安重庆风险闭环管控机制',
                    a: '计划内容',
                    c: '上线应用平台',
                    isOver: 1,
                },
                {
                    id: 18,
                    name: '健全平安重庆风险闭环管控机制',
                    a: '计划内容',
                    c: '上线应用平台',
                    isOver: 0,
                },
                {
                    id: 19,
                    name: '推进渝警数智“情指行”一体化现代警务改革',
                    a: '计划内容',
                    c: '上线应用平台',
                    isOver: 1,
                },
                {
                    id: 20,
                    name: '建立领导班子运行评估和群众口碑评价机制',
                    a: '计划内容',
                    c: '上线应用平台',
                    isOver: 0,
                },
                {
                    id: 21,
                    name: '推进“党建扎桩·治理结网”基层治理现代化改革',
                    a: '计划内容',
                    c: '搭建重要平台',
                    isOver: 1,
                },
                {
                    id: 22,
                    name: '推进“党建扎桩·治理结网”基层治理现代化改革',
                    a: '计划内容',
                    c: '搭建重要平台',
                    isOver: 0,
                },
                {
                    id: 23,
                    name: '推进“党建扎桩·治理结网”基层治理现代化改革',
                    a: '计划内容',
                    c: '搭建重要平台',
                },
                {
                    id: 24,
                    name: '实施投融资多元化改革',
                    a: '计划内容',
                    c: '搭建重要平台',
                    isOver: 0,
                },
                {
                    id: 25,
                    name: '实施投融资多元化改革',
                    a: '计划内容',
                    c: '搭建重要平台',
                    isOver: 1,
                },
            ],
            // tableData: [],
            templateData: [],
            columnIndexFixed: [0, 1], // 固定列序号
            columnIndexGather: {}, //固定列序需合并行号集合
            columnIndexTargetName: {}, // 改革核心指标名称需合并行号
            cgxs: [],
        }
    },
    mounted() {
        this.dataFormat()
        // this.initData()
    },
    methods: {
        initData() {
            this.cgxs = utils.getDictItemsFromCache('cgxs')
            this.loading = true
            let now = new Date()
            let y = now.getFullYear()
            let m = now.getMonth() + 1
            let data = this.qs.stringify({
                fillMonth: m,
                fillYear: y,
            })
            apiList.queryMonthPlanList(data, (res) => {
                if (res) {
                    this.templateData = res
                    this.dataFormat()
                    this.tableData = this.templateData
                }
                this.loading = false
            })
        },
        dataFormat() {
            let initNum = 0
            // 先计算需合并的行号
            this.templateData.forEach((item, index) => {
                this.cgxs.forEach((dict) => {
                    if (dict.value == item.planType) {
                        item.planTypeName = dict.name
                    }
                })
                if (!this.columnIndexGather[item.indexKey]) {
                    this.columnIndexGather[item.indexKey] = [index]
                    initNum++
                } else {
                    this.columnIndexGather[item.indexKey].push(index)
                }
                item.indexKey = initNum
                if (
                    !this.columnIndexTargetName[
                        item.reformQuantitativeObjectives
                    ]
                ) {
                    this.columnIndexTargetName[
                        item.reformQuantitativeObjectives
                    ] = [index]
                } else {
                    this.columnIndexTargetName[
                        item.reformQuantitativeObjectives
                    ].push(index)
                }
            })
            for (let key in this.columnIndexGather) {
                if (this.columnIndexGather[key].length <= 1) {
                    delete this.columnIndexGather[key]
                }
            }
            for (let key in this.columnIndexTargetName) {
                if (this.columnIndexTargetName[key].length <= 1) {
                    delete this.columnIndexTargetName[key]
                }
            }
            this.dataReady = true
        },
        objectSpanMethod({row, column, rowIndex, columnIndex}) {
            if (this.columnIndexFixed.includes(columnIndex)) {
                for (let key in this.columnIndexGather) {
                    if (rowIndex === this.columnIndexGather[key][0]) {
                        return {
                            rowspan: this.columnIndexGather[key].length,
                            colspan: 1,
                        }
                    } else if (
                        this.columnIndexGather[key].includes(rowIndex) &&
                        rowIndex !== this.columnIndexGather[key][0]
                    ) {
                        return {
                            rowspan: 0,
                            colspan: 0,
                        }
                    }
                }
            }
        },
    },
}
</script>
<style lang="scss">
@import './table.scss';

</style>
<style lang="scss">

// .report-overview {
//     height: 700px;
// }
#mix-table-bigger .el-table--border th, .el-table--border td {
    border-right: 1px solid rgb(39, 86, 162)!important;
}
#mix-table-bigger.el-table th.el-table__cell.is-leaf, #mix-table-bigger.el-table td.el-table__cell {
    border-bottom: 1px solid rgb(39, 86, 162)!important;
}

#mix-table-bigger.dialog_table.el-table{
    // tr {
    //     background-color: rgba(1, 39, 101, 1)!important;
    //     color: #FFFFFF!important;
    // }
    // tr:nth-of-type(2n+1){
    //     background-color: rgb(3, 45, 113)!important;
    //     color: #FFFFFF!important;
    // }

    thead tr{
        background: none!important;
    }
    thead tr, thead tr th{
        background: none!important;
        background-color: #114385!important;
        color: #FFFFFF;
    }
    th > .cell {
        font-size: 14px;
        font-family: SimHei;
        font-weight: 400;
        color: #FFFFFF;
    }
    td > .cell {
        color: #FFFFFF!important;
    }
}
    
#mix-table-bigger.el-table--border{
    border: 1px solid rgb(39, 86, 162)!important;
    .el-table__cell{
        border-right: 1px solid rgb(39, 86, 162)!important;
    }
    th.el-table__cell {
        border-bottom: 1px solid rgb(39, 86, 162)!important;
    }
    td {
        border-right: 1px solid rgb(39, 86, 162)!important;
    }
    th {
        border-right: 1px solid rgb(39, 86, 162)!important;
    }
}
#mix-table-bigger.el-table{
    tr {
        background-color: rgba(1, 39, 101, 1)!important;
        color: #FFFFFF!important;
    }
}
#mix-table-bigger .el-table--enable-row-hover .el-table__body tr:hover > td.el-table__cell {
    background-color: rgba(2, 115, 233, 0.3)!important;
}
#mix-table-bigger.el-table.el-table--border tbody tr:hover > td {
    background-color: rgba(2, 115, 233, 0.3)!important;
}

#mix-table-bigger.el-table--group::after, 
#mix-table-bigger.el-table--border::after, 
#mix-table-bigger.el-table::before {
    background-color: #001f47!important;
}
#mix-table-bigger{
    /* 设置滚动条的样式 */
    ::-webkit-scrollbar {
        width: 8px !important; //垂直方向上的宽
        height: 8px !important; //水平方向上的宽
    }
    
    /* 滚动槽 */
    ::-webkit-scrollbar-track {
        background-color: #01215a !important;
    }
    
    /* 滚动条滑块 */
    ::-webkit-scrollbar-thumb {
        border-radius: 6px;
        background-color: rgba(#fff, 0.1) !important;
    }
    /*滚动条交叉样式*/
    ::-webkit-scrollbar-corner {
        background: #01215a !important;
    }
}
</style >